# -*- coding: utf-8 -*-
# Generated by Django 1.11.13 on 2018-05-13 12:49
from __future__ import unicode_literals

from django.db import migrations, models
from django.db.models import Min
import django.db.models.deletion


def migrate_seat(apps, schema_editor):
    Attendance = apps.get_model('events', 'Attendance')
    UserProfile = apps.get_model('accounts', 'UserProfile')
    for user in UserProfile.objects.all():
        for team in user.teams.annotate(Min('at_event__episode__start_date')).order_by('at_event__episode__start_date__min'):
            attendance = Attendance(event=team.at_event, user=user, seat='')
            attendance.save()
        attendance.seat = user.seat
        attendance.save()


def revert_seat(apps, schema_editor):
    Attendance = apps.get_model('events', 'Attendance')
    UserProfile = apps.get_model('accounts', 'UserProfile')
    for user in UserProfile.objects.all():
        attendance = user.attendance_set.annotate(Min('event__episode__start_date')).order_by('-at_event__episode__start_date__min').first()
        user.seat = attendance.seat
        user.save()


class Migration(migrations.Migration):

    dependencies = [
        ('events', '0003_merge_20180603_1925'),
    ]

    operations = [
        migrations.CreateModel(
            name='Attendance',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('seat', models.CharField(blank=True, default='', help_text='Enter your seat so we can find you easily if you get stuck. (To help you, not to mock you <3)', max_length=12)),
                ('event', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='events.Event')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='accounts.UserProfile')),
            ],
        ),
        migrations.RunPython(migrate_seat, reverse_code=revert_seat, elidable=True),
    ]
